﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.IO;
using System.IO.MemoryMappedFiles;
using System.Runtime.InteropServices;


namespace Erettsegi30_FejVagyÍrás
{
    class FejVagyIras
    {
        static void Main()
        {
            Random r = new Random();
            Console.WriteLine("1. feladat\nA pénzfeldobás eredménye: {0}", r.Next(2) == 0 ? 'F' : 'I');

            Console.Write("2. feladat\nTippeljen! (F/I)= ");
            char tipp = Char.ToUpper(Console.ReadKey().KeyChar);
            char dobás = r.Next(2) == 0 ? 'F' : 'I';
            Console.WriteLine("\nA tipp {0}, a dobás eredménye {1} volt.\nÖn {2}.", tipp, dobás, tipp == dobás ? "eltalálta" : "nem találta el");

            //számítások a 3.-6. feladatokhoz:
            StreamReader sr = new StreamReader("kiserlet.txt");
            int db = 0; //3. feladathoz: dobások száma és a dobás sorszáma
            int fejdb = 0; //4. feladathoz: fejdobások száma
            int duplaFejDb = 0; //5. feladathoz: duplafej sorozatok száma
            int aktFejDb = 0; //5. és 6. feladathoz: aktuális fejsorozat hossza
            int maxFejDb = 0; //6. feladathoz: leghosszabb fejsorozat hossza
            int maxFejSsz = 0; //6. feladathoz: leghosszabb fejsorozat utolsó dobásának sorszáma

            while (!sr.EndOfStream)
            {
                string sor = sr.ReadLine();
                db++; //dobás sorszámát is jelzi
                if (sor == "F")
                {
                    fejdb++; //4. feladathoz
                    aktFejDb++; //5. és 6. feladathoz
                }
                if (sor == "I" || (sor == "F" && sr.EndOfStream)) //5. és 6. feladathoz
                {
                    if (aktFejDb == 2) duplaFejDb++; //5. feladathoz
                    if (aktFejDb > maxFejDb) //6. feladathoz
                    {
                        maxFejDb = aktFejDb;
                        maxFejSsz = db - maxFejDb + (sor == "F" && sr.EndOfStream ? 1 : 0);
                    }
                    aktFejDb = 0; //5. és 6. feladathoz
                }
            }
            sr.Close();

            Console.WriteLine("3. feladat\nA kísérlet {0} dobásból állt.", db);

            Console.WriteLine("4. feladat\nA kísérlet során a fej relatív gyakorisága {0:P2} volt.", (double)fejdb / db);

            Console.WriteLine("5. feladat\nA kísérlet során {0} alkalommal dobtak pontosan két fejet egymás után.", duplaFejDb);

            Console.WriteLine("6. feladat\nA leghosszabb tisztafej sorozat {0} tagból áll, kezdete a(z) {1}. dobás.", maxFejDb, maxFejSsz);

            //7. feladat
            int ffffDb = 0; int fffiDb = 0; string ki = string.Empty;
            for (int i = 0; i < 1000; i++)
            {
                string d = string.Empty;
                for (int j = 0; j < 4; j++) d += "FI"[r.Next(2)];
                if (d.Equals("FFFF")) ffffDb++;
                if (d.Equals("FFFI")) fffiDb++;
                ki += d + ' ';
            }
            File.WriteAllText("dobasok.txt", String.Format("FFFF: {0}, FFFI: {1}\r\n{2}", ffffDb, fffiDb, ki.TrimEnd()));

            Console.ReadKey();
        }
    }
}
